/*===========================================================*\
\*===========================================================*/
#if !defined(__DEVICE_THREAD_H__)
#define __DEVICE_THREAD_H__

#include "Win32Thread.h"
#include "Win32Mutex.h"
#include "InterruptException.h"
#include "Win32Synchronizer.h"

class DeviceThread : public Win32Thread
{
  public:
    DeviceThread(std::string name) : Win32Thread(name)  {}
    virtual Tx::ThreadMediator & ThreadMediator()   
        {return _mediator;}

  private:
    typedef 
      Tx::Win32Synchronizer <InterruptException, Win32Mutex>
                EventSynchronizer_t;
    typedef 
      Tx::ThreadMediatorImpl <EventSynchronizer_t>
                Mediator_t;

    virtual int Run();

    Mediator_t  _mediator;
};


#endif // __DEVICE_THREAD_H__
