/*===========================================================*\
    This file is to provide a screen output function
    which is shareable by multiple threads, and prevents
    text output from different threads to be interleaved.
\*===========================================================*/
#include <iostream>
#include <windows.h>
#include "Miscellaneous.h"
#include <math.h>

//=============================================================
namespace
{
    bool                bRanFirstTime = true;
    bool                bCSFirstTime = true;
    CRITICAL_SECTION    cs;
}


//=============================================================
void Print(std::string msg)
{
    if (bCSFirstTime)
    {
        ::InitializeCriticalSection( &cs );
        bCSFirstTime = false;
    }

    ::EnterCriticalSection( &cs );
    std::cout << msg << std::endl;
    ::LeaveCriticalSection( &cs );
}

//=============================================================
int RandomDelay()
{
    if (bRanFirstTime)
    {
        srand(0);
        bRanFirstTime = false;
    }

    const int HI = 5000;
    const int LO = 2000;
    return (rand() + LO) % HI;
}