/*===========================================================*\
\*===========================================================*/
#if !defined(__MONITOR_THREAD_H__)
#define __MONITOR_THREAD_H__

#include "Win32Thread.h"
#include "Win32Mutex.h"
#include "InterruptException.h"
#include "Win32Synchronizer.h"
#include "Miscellaneous.h"

class MonitorThread : public Win32Thread
{
  public:
    MonitorThread(std::string name, int period) 
        : Win32Thread(name), _period(period)    {}
    virtual Tx::ThreadMediator & ThreadMediator()   
        {return _mediator;}

  private:
    typedef 
      Tx::Win32Synchronizer <InterruptException, Win32Mutex>
                EventSynchronizer_t;
    typedef 
      Tx::ThreadMediatorImpl <EventSynchronizer_t>
                Mediator_t;

    virtual int Run();

    void DoSomeWork();

    Mediator_t  _mediator;
    int         _period;
};


#endif // __MONITOR_THREAD_H__
