/*===========================================================*\
\*===========================================================*/
#if !defined(__SOCKET_THREAD_H__)
#define __SOCKET_THREAD_H__

#include "Win32Thread.h"
#include "Win32Mutex.h"
#include "InterruptException.h"
#include "SocketSynchronizer.h"

class SocketThread : public Win32Thread
{
  public:
    SocketThread(std::string name) : Win32Thread(name)  {}
    virtual Tx::ThreadMediator & ThreadMediator()   
        {return _mediator;}

  private:
    typedef 
      Tx::SocketSynchronizer <InterruptException, Win32Mutex>
                SocketSynchronizer_t;
    typedef 
      Tx::ThreadMediatorImpl <SocketSynchronizer_t>
                Mediator_t;

    virtual int Run();

    void ReadFromSocket(SOCKET socketHandle);

    Mediator_t  _mediator;
};


#endif // __SOCKET_THREAD_H__
