/*===========================================================*\
\*===========================================================*/
#if !defined(__WIN32_MUTEX_H__)
#define __WIN32_MUTEX_H__

#include <windows.h>

// Simple wrapper for thread synchronization object.
// Replace with your platform's implementation.
class Win32Mutex
{
  public:
    Win32Mutex()          {::InitializeCriticalSection(&_cs);}
    virtual ~Win32Mutex() {::DeleteCriticalSection(&_cs);}
    void Lock()           {::EnterCriticalSection(&_cs);}
    void Unlock()         {::LeaveCriticalSection(&_cs);}
  private:
    CRITICAL_SECTION      _cs;
};

#endif // __WIN32_MUTEX_H__
