/*===========================================================*\
    This is very simple thread base class, for consolidating
    some of the busy work of starting and stopping threads
    in this example code.
\*===========================================================*/
#include <process.h>
#include "Win32Thread.h"


//=============================================================
bool Win32Thread::Start()
{
    _handle = (HANDLE)
        ::_beginthread( StaticStartFunction, 0, this);
    return (_handle != HANDLE(-1));
}


//=============================================================
bool Win32Thread::Signal()
{
    ThreadMediator().Signal(); 
    return true;
}


//=============================================================
bool Win32Thread::WaitToExit()
{
    return (::WaitForSingleObject(_handle, INFINITE) 
                != WAIT_TIMEOUT);
}


//=============================================================
void Win32Thread::StaticStartFunction(void * arg)
{
    Win32Thread * pObj = reinterpret_cast <Win32Thread *> 
            (arg);
    pObj->Run();
}

