/*===========================================================*\
\*===========================================================*/
#if !defined(__WIN32_THREAD_H__)
#define __WIN32_THREAD_H__

#include <windows.h>
#include "ThreadMediator.h"
#include <string>

// Simple wrapper for thread objects.
// Replace with your own implementation.
class Win32Thread
{
  public:
    bool Start();
    bool Signal();
    bool WaitToExit();
    std::string Name()  {return _name;}

  protected:
    Win32Thread(std::string name) : _name(name) {}
    virtual Tx::ThreadMediator & ThreadMediator() = 0;
    virtual int Run() = 0;

  private:
    static void StaticStartFunction(void * arg);
    HANDLE      _handle;
    std::string _name;
};

#endif // __WIN32_THREAD_H__
