/*
 * list.c - manage simple lists of strings
 *
 * $Id: list.c,v 1.2 2003/02/11 16:12:34 danny Exp $
 *
 * THE BEER-WARE LICENSE
 *
 * <danny@alphazed.com> wrote this software. As long as you retain this notice,
 * you can do whatever you want with this stuff.  If we meet some day, and you
 * think this stuff is worth it, you can buy me a beer in return.
 *
 * Daniel Lawrence
 */

#include <stdio.h>
#include <stdlib.h>
#include "list.h"

void
list_init(LIST *l)
{
	l->alloc = 0;
	l->size = 0;
	l->a = NULL;
}


/* list_add -- add string to end of list
 *             string is not dup'ed
 */
int
list_add(LIST *l, char *s)
{
	char **p;

	if (l->alloc == 0) {
		if ((p = (char **)malloc(sizeof(char *))) == NULL)
			return 0;
		l->a = p;
		l->alloc = 1;
	} else if (l->size >= l->alloc) {
		if ((p = (char **)realloc(l->a, 2 * l->alloc * sizeof(char *))) == NULL)
			return 0;
		l->a = p;
		l->alloc *= 2;
	}
	l->a[l->size++] = s;
	return 1;
}


int
list_size(LIST *l)
{
	return l->size;
}


char *
list_get(LIST *l, int n)
{
	return (n < 0 || n >= l->size) ? NULL : l->a[n];
}


void
list_free(LIST *l)
{
	if (l->a)
		free(l->a);
	l->alloc = 0;
	l->size = 0;
}
