/*
 * readdb_test.c
 *
 * $Id: readdb_test.c,v 1.2 2003/02/11 16:12:34 danny Exp $
 *
 * THE BEER-WARE LICENSE
 *
 * <danny@alphazed.com> wrote this software. As long as you retain this notice,
 * you can do whatever you want with this stuff.  If we meet some day, and you
 * think this stuff is worth it, you can buy me a beer in return.
 *
 * Daniel Lawrence
 */

#include <stdio.h>
#include <stdlib.h>	/* for atexit */
#include <string.h>
#include <errno.h>
#include <toolbox.h>
#include "var.h"
#include "sym.h"
#include "res.h"
#include "readdb.h"

int
main(int argc, char **argv)
{
	char *msg = NULL;

	atexit(tb_strdump);

	msg = readdb(stdin, msg);
	if (msg == NULL)
		printf("out of memory\n");
	else if (msg[0] == '\0')
		sym_print();
	else
		printf("%s\n", msg);

	printf("=== eval(\"default\") ===\n");
	{
		RESULT res;
		int n;
		int i;
		char *var;
		char *val;

		if (!res_init(&res))
			printf("res_init: out of memory\n");
		else if ((msg = sym_eval("default", &res, msg)) == NULL)
			printf("eval: out of memory\n");
		else if (msg[0] == '\0') {
			printf("environment:\n");
			n = var_size(&res.env);
			for (i = 0; i < n; ++i) {
				var_get(&res.env, i, &var, &val);
				printf("\t%s=%s\n", var, val);
			}
			printf("path: %s\n", res.path);
			printf("manpath: %s\n", res.manpath);
		} else
			printf("%s\n", msg);
	}
	exit(0);
}
