/*
 * res.c
 *
 * $Id: res.c,v 1.4 2003/02/13 16:58:34 danny Exp $
 *
 * THE BEER-WARE LICENSE
 *
 * <danny@alphazed.com> wrote this software. As long as you retain this notice,
 * you can do whatever you want with this stuff.  If we meet some day, and you
 * think this stuff is worth it, you can buy me a beer in return.
 *
 * Daniel Lawrence
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <toolbox.h>
#include "var.h"
#include "res.h"

int
res_init(RESULT *res)
{
	var_init(&res->env);
	if ((res->path = tb_strcpy(NULL, "")) == NULL)
		return 0;
	if ((res->manpath = tb_strcpy(NULL, "")) == NULL) {
		tb_strfree(res->path);
		return 0;
	}
	return 1;
}


/* res_env -- add an environment name-val pair */
int
res_env(RESULT *res, char *var, char *val)
{
	return var_add(&res->env, var, val);
}


/* res_path -- add an element to PATH */
int
res_path(RESULT *r, char *path)
{
	if (strlen(r->path) && strlen(path))
		if ((r->path = tb_strcat(r->path, ":", NULL)) == NULL)
			return 0;
	if ((r->path = tb_strcat(r->path, path, NULL)) == NULL)
		return 0;
	return 1;
}


/* res_manpath -- add an element to manpath */
int
res_manpath(RESULT *r, char *manpath)
{
	if (strlen(r->manpath) && strlen(manpath))
		if ((r->manpath = tb_strcat(r->manpath, ":", NULL)) == NULL)
			return 0;
	if ((r->manpath = tb_strcat(r->manpath, manpath, NULL)) == NULL)
		return 0;
	return 1;
}


/* res_print_sh -- print symbol table in /bin/sh format */
void
res_print_sh(FILE *f, RESULT *r)
{
	int n;
	int i;
	char *var;
	char *val;

	n = var_size(&r->env);
	for (i = 0; i < n; ++i) {
		var_get(&r->env, i, &var, &val);
		fprintf(f, "%s=\"%s\";\n", var, val);
		fprintf(f, "export %s;\n", var);
	}

	fprintf(f, "PATH=%s;\n", r->path);
	fprintf(f, "export PATH;\n");
	fprintf(f, "MANPATH=%s;\n", r->manpath);
	fprintf(f, "export MANPATH;\n");
}


/* res_print_csh -- print symbol table in /bin/csh format */
void
res_print_csh(FILE *f, RESULT *r)
{
	int n;
	int i;
	char *var;
	char *val;

	fprintf(f, "set noglob;\n");
	n = var_size(&r->env);
	for (i = 0; i < n; ++i) {
		var_get(&r->env, i, &var, &val);
		fprintf(f, "setenv %s %s;\n", var, val);
	}
	fprintf(f, "setenv PATH %s;\n", r->path);
	fprintf(f, "setenv MANPATH %s;\n", r->manpath);
	fprintf(f, "unset noglob;\n");
}
