/*
 * var.c - manage lists of name-value pairs
 *
 * $Id: var.c,v 1.2 2003/02/11 16:12:34 danny Exp $
 *
 * THE BEER-WARE LICENSE
 *
 * <danny@alphazed.com> wrote this software. As long as you retain this notice,
 * you can do whatever you want with this stuff.  If we meet some day, and you
 * think this stuff is worth it, you can buy me a beer in return.
 *
 * Daniel Lawrence
 */

#include <stdio.h>
#include <stdlib.h>
#include "var.h"

void
var_init(VAR *v)
{
	v->alloc = 0;
	v->size = 0;
	v->a = NULL;
}


/* var_add -- add name-value pair to end of list
 *            strings are not dup'ed
 */
int
var_add(VAR *v, char *name, char *val)
{
	PAIR *p;


	if (v->alloc == 0) {
		if ((p = (PAIR *)malloc(sizeof(PAIR))) == NULL)
			return 0;
		v->a = p;
		v->alloc = 1;
	} else if (v->size >= v->alloc) {
		if ((p = (PAIR *)realloc(v->a, 2 * v->alloc * sizeof(PAIR))) == NULL)
			return 0;
		v->a = p;
		v->alloc *= 2;
	}
	v->a[v->size].name = name;
	v->a[v->size].val = val;
	++v->size;
	return 1;
}


int
var_size(VAR *v)
{
	return v->size;
}


int
var_get(VAR *v, int n, char **namep, char **valp)
{
	if (n < 0 || n >= v->size)
		return 0;
	*namep = v->a[n].name;
	*valp = v->a[n].val;
	return 1;
}


void
var_free(VAR *v)
{
	if (v->a)
		free(v->a);
	v->alloc = 0;
	v->size = 0;
}
