/*
 * cp.c -- copy file
 *
 * $Id: cp.c,v 1.2 2003/02/11 16:01:45 danny Exp $
 *
 * THE BEER-WARE LICENSE
 *
 * <danny@alphazed.com> wrote this software. As long as you retain this notice,
 * you can do whatever you want with this stuff.  If we meet some day, and you
 * think this stuff is worth it, you can buy me a beer in return.
 *
 * Daniel Lawrence
 */

#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <errno.h>
#include "toolbox.h"

int
tb_cp(int src, int dst, char **msgp)
{
	char buf[8 * 1024];
	ssize_t n;
	ssize_t w;
	ssize_t i;

	while ((n = read(src, buf, sizeof(buf))) > 0)
		for (i = 0; i < n; i += w)
			if ((w = write(dst, buf + i, n - i)) == -1) {
				*msgp = tb_strprintf(
					*msgp,
					"write: %s (%d)",
					strerror(errno),
					errno
				);
				return 0;
			}
	if (n == -1) {
		*msgp = tb_strprintf(
			*msgp,
			"read: %s (%d)",
			strerror(errno),
			errno
		);
		return 0;
	}
	return 1;
}
