.\" mktmp.man
.\" $Id: mktmp.man,v 1.1 2003/02/07 17:36:43 danny Exp $
.TH tb_mktmp 3
.SH NAME
tb_mktmp - create temporary file
.SH LIBRARY
Toolbox (-ltoolbox)
.SH SYNOPSIS
.nf
#include <toolbox.h>

int
tb_mktmp(char *prefix, char **pathp, int *err);
.fi
.SH DESCRIPTION
tb_mktmp() creates a uniquely named temporary file.
The name of the file consists of the concatenation of the following:
.sp
<prefix><time>.M<microseconds>P<pid>Q<generation>.<hostname>

<time> is the tv_sec element of gettimeofday().
<microseconds> is the tv_usec element of gettimeofday().
<pid> is the current process id.
<generation> is a counter which is incremented on every successful temporary
file creation.
<hostname> is from tb_gethostname().

tb_mktmp() uses the O_CREAT and O_EXCL flags in the open() call to ensure a
file with the generated name does not already exist.
If a file with the same name already exists, tb_mktmp() sleeps for 2 seconds
and tries again.

The file will be created with mode 0600 as modified by the current umask.

The path to the temporary file will be copied to the dynamic string *pathp
if tb_mktmp() is successful.
.SH RETURN VALUES
If tb_mktmp() is successful, the fd of the opened file will be returned.
Otherwise, -1 is returned and *err is set to one of the following:
.TP
TB_EMEM
A dynamic string function couldn't allocate enough memory.
.TP
TB_EERRNO
A system call failed; check errno for specifics.
.SH SEE ALSO
mktemp(3),
mkstemp(3)
.br
http://cr.yp.to/proto/maildir.html
.SH BUGS
tb_mktmp() uses static variables and is not re-entrant.
