/*
 * modeof.c
 *
 * $Id: modeof.c,v 1.2 2003/02/11 16:01:45 danny Exp $
 *
 * THE BEER-WARE LICENSE
 *
 * <danny@alphazed.com> wrote this software. As long as you retain this notice,
 * you can do whatever you want with this stuff.  If we meet some day, and you
 * think this stuff is worth it, you can buy me a beer in return.
 *
 * Daniel Lawrence
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <errno.h>
#include <assert.h>
#include <ctype.h>
#include "toolbox.h"

int
tb_modeof(char *s, mode_t *modep)
{
	unsigned long ul;
	mode_t mode;

	/* mode range detection only works if unsigned long
	 * is as least as big as mode_t. if your mode_t is
	 * bigger than unsigned long, a larger unsigned type
	 * will have to be used.
	 */
	assert(sizeof(mode_t) <= sizeof(unsigned long));

	while (*s && (*s == ' ' || *s == '\t'))
		++s;

	if (!isdigit(*s))
		return 0;

	errno = 0;
	ul = strtoul(s, NULL, 0);
	if (errno != 0)
		return 0;

	mode = ul;
	if (mode != ul)		/* check if value was truncated */
		return 0;
	*modep = mode;
	return 1;
}
