/*
 * strcat.c
 *
 * $Id: strcat.c,v 1.2 2003/02/11 16:01:45 danny Exp $
 *
 * THE BEER-WARE LICENSE
 *
 * <danny@alphazed.com> wrote this software. As long as you retain this notice,
 * you can do whatever you want with this stuff.  If we meet some day, and you
 * think this stuff is worth it, you can buy me a beer in return.
 *
 * Daniel Lawrence
 */

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include "toolbox.h"
#include "tb__string.h"

char *
tb_strcat(char *dst, ...)
{
	va_list args;
	tb__string *p;
	size_t size;
	char *cp;
	char *news;

	if (dst == NULL) {
		if ((p = tb__stralloc("")) == NULL)
			return NULL;
	} else if ((p = tb__strlookup(dst)) == NULL) {
		fprintf(stderr, "tb_strcat: martian\n");
		abort();
	}

	/* initial scan through args to get total length */
	size = strlen(p->s) + 1;	/* string alread in dst + \0 */
	va_start(args, dst);
	while ((cp = va_arg(args, char *)) != NULL)
		size += strlen(cp);
	va_end(args);

	if (size > p->size) {
		if ((news = realloc(p->s, size)) == NULL) {
			tb__strfree(p);
			return NULL;
		}
		p->s = news;
		p->size = size;
	}

	/* scan through args again to collect strings */
	va_start(args, dst);
	while ((cp = va_arg(args, char *)) != NULL)
		strcat(p->s, cp);
	va_end(args);

	return p->s;
}
