/*
 * strgetline.c
 *
 * $Id: strgetline.c,v 1.2 2003/02/11 16:01:45 danny Exp $
 *
 * THE BEER-WARE LICENSE
 *
 * <danny@alphazed.com> wrote this software. As long as you retain this notice,
 * you can do whatever you want with this stuff.  If we meet some day, and you
 * think this stuff is worth it, you can buy me a beer in return.
 *
 * Daniel Lawrence
 */

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include "toolbox.h"
#include "tb__string.h"

char *
tb_strgetline(char *buf, FILE *f, int *err)
{
	tb__string *p;
	int i;
	int c;
	char *news;

	if (buf == NULL) {
		if ((p = tb__stralloc("")) == NULL) {
			if (err)
				*err = TB_EMEM;
			return NULL;
		}
	} else if ((p = tb__strlookup(buf)) == NULL) {
		fprintf(stderr, "tb_strgetline: martian\n");
		abort();
	}

	i = 0;
	while ((c = fgetc(f)) != EOF) {
		if (i >= p->size-1) {
			if ((news = realloc(p->s, 2 * p->size)) == NULL) {
				tb__strfree(p);
				if (err)
					*err = TB_EMEM;
				return NULL;
			}
			p->s = news;
			p->size *= 2;
		}
		if (c == '\n')
			break;
		p->s[i++] = c;
	}
	if (ferror(f)) {
		tb__strfree(p);
		if (err)
			*err = TB_EERRNO;
		return NULL;
	}
	if (feof(f)) {
		tb__strfree(p);
		if (err)
			*err = TB_EOK;
		return NULL;
	}
	p->s[i] = '\0';
	if (err)
		*err = TB_EOK;
	return p->s;
}
