/*
 * strncpy.c
 *
 * $Id: strncpy.c,v 1.2 2003/02/11 16:01:45 danny Exp $
 *
 * THE BEER-WARE LICENSE
 *
 * <danny@alphazed.com> wrote this software. As long as you retain this notice,
 * you can do whatever you want with this stuff.  If we meet some day, and you
 * think this stuff is worth it, you can buy me a beer in return.
 *
 * Daniel Lawrence
 */

#include <string.h>
#include <stdlib.h>
#include "toolbox.h"
#include "tb__string.h"

char *
tb_strncpy(char *dst, char *src, size_t n)
{
	tb__string *p;
	size_t size;
	char *news;

	if (dst == NULL) {
		if ((p = tb__stralloc("")) == NULL)
			return NULL;
	} else if ((p = tb__strlookup(dst)) == NULL) {
		fprintf(stderr, "tb_strncpy: martian\n");
		abort();
	}

	size = strlen(src);
	if (n < size)
		size = n;
	size += 1;

	if (size > p->size) {
		if ((news = realloc(p->s, size)) == NULL) {
			tb__strfree(p);
			return NULL;
		}
		p->s = news;
		p->size = size;
	}

	strncpy(p->s, src, size-1);
	p->s[size-1] = '\0';
	return p->s;
}
