/*
 * toolbox.h
 *
 * $Id: toolbox.h,v 1.5 2003/02/25 13:32:12 danny Exp $
 *
 * THE BEER-WARE LICENSE
 *
 * <danny@alphazed.com> wrote this software. As long as you retain this notice,
 * you can do whatever you want with this stuff.  If we meet some day, and you
 * think this stuff is worth it, you can buy me a beer in return.
 *
 * Daniel Lawrence
 */

#ifndef TOOLBOX_H
#define	TOOLBOX_H

#include <stdio.h>
#include <sys/types.h>

/* various error codes which may be returned by toolbox functions */
enum {
	TB_EOK = 0,	/* no error */
	TB_EMEM = 1,	/* out of memory */
	TB_EERRNO = 2	/* errno contains error from lower level call */
};


int tb_cp(int, int, char **);
char *tb_gethostname(void);
char *tb_getprogname(void);
int tb_gidof(char *, gid_t *);
int tb_mkdirp(char *, uid_t, gid_t, mode_t, char **);
int tb_mktmp(char *, char **, int *);
int tb_modeof(char *, mode_t *);
char *tb_salt(char *, char *, int (*)(int));
void tb_setprogname(char *);
int tb_uidof(char *, uid_t *);

char *tb_rtrimc(char *, int);
char *tb_rtrims(char *, char *);

void tb_die_msg(char *);
void tb_die_printf(char *, ...);


char *tb_strcpy(char *, char *);
char *tb_strncpy(char *, char *, size_t);
char *tb_strcat(char *, ...);
char *tb_strcatc(char *, int);
char *tb_strprintf(char *, char *, ...);
char *tb_strgetline(char *, FILE *, int *);
char *tb_strfree(char *);
void tb_strdump(void);

#endif
