/**************************************************************************
 * Copyright (c) 2002 Edward Elliott. All rights reserved.
 * Allocation Policies
 * 
 * Policies for allocating memory and possibly locking it into
 * volatile memory (physical ram).
 *************************************************************************/

#ifndef ALLOCPOL_H
#define ALLOCPOL_H

#include "NoSwapDLMalloc.h"

#if defined(_WIN32)

	#include "NoSwapHeap.h"
	typedef NoSwapHeap	NoSwapAlloc;

#else

	typedef NoSwapDLMalloc	NoSwapAlloc;

#endif

/**
 * Wrapper around normal malloc.
 * Don't use unless system takes steps to protect swap file.
 */
class JustPlainMalloc : public DummyMaxCount
{
public:
	void* doAlloc(size_t numBytes, const void* hint)
	{
		return malloc(numBytes);
	}

	void doFree(void* pmem, size_t numBytes)
	{
		free(pmem);
	}
};

#endif	// ALLOCPOL_H
